// This script hands Pyreals (one at a time) to a Town Crier to collect Violet Balls.
//
// Change these settings to suit your character
var LogOnDeath = false;		// true will log off at the LS if you die.
var FullPackCount = 100;        // Max items in main pack which triggers a script stop
var FullPackLog = false; 	// Logoff if pack is full
var TimedLogoff = false;        // true wil auto stop and logoff after x hours
var TimedStopCount = 5;         // number of hours to run before auto stop and logoff
var VioletMax = 6;              // Max to have/collect before stopping.
var DoMax = true;               // Stop after a max count
var BallDelay = 2;              // time gap between attempts (in seconds)

var PalVersion = "SMInc Violet v1.11.21.0         2004-11-21"

macroDir = "d:\\Progra~1\\SkunkWorks\\Libraries\\"

alertAdminWav	= skapi.WavNew(macroDir+"broadcast.wav");	// Played when admin detected
alertDeathWav	= skapi.WavNew(macroDir+"dead.wav");		// Sound to play when we die
alertPlayerWav	= skapi.WavNew(macroDir+"fellow.wav");  	// Played when another player detected
alertCompsWav	= skapi.WavNew(macroDir+"portal.wav");		// Played when comps low
alertTellWav	= skapi.WavNew(macroDir+"patron.wav");		// Played when @tell message detected
alertVioletWav	= skapi.WavNew(macroDir+"vassel.wav");  	// Played when Violet Ball found

// Internal Variables, change at own risk

//raw
var h = new myHandlers();
var Go;
var opmAll = (opmDebugLog | opmChatWnd | opmConsole);
var Start;
var szSchema;
var First = true;
var pdwDxp3D, pdwDyp3D;
var pxtIsOpen;

//main
var StartPackCount = 0;        // Starter value for number of items in main pack
var OldPackCount = 0;          // Temporary value for number of items in main pack
var RunningClock;
var DebugFlag = false;
var Pyreal;
var Pyreal1;
var InitialViolet;
var TotalViolet;
var CrierAco;
var CrierLoc;
var BurdenFull;
var BurdenCurrent;

function MyHandlers_OnControlEvent(szPanel, szControl, dictSzValue)
{
	var BoolCheck;
	if (szPanel == "SMIncViolet")
	{
		switch (szControl)
		{
		case 'chkMax':
			DoMax = (dictSzValue('chkMax')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - Stop at Maximum now " + dictSzValue('chkMax'), opmAll);
			break;
		case 'edtMax':
			VioletMax = dictSzValue('edtMax');
                        SmincAmber();
			skapi.OutputLine("Edited: Maximum balls to collect now " + dictSzValue('edtMax') + " items", opmAll);
			break;

		case 'edtFPC':
			FullPackCount = dictSzValue('edtFPC');
                        SmincAmber();
			skapi.OutputLine("Edited: Full Pack Count - now maxed at " + dictSzValue('edtFPC') + " items", opmAll);
			break;
		case 'chkFPL':
			FullPackLog = (dictSzValue('chkFPL')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - Log On Full Pack now " + dictSzValue('chkFPL'), opmAll);
			break;

		case 'chkDebugFlag':
			DebugFlag = (dictSzValue('chkDebugFlag')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - DebugFlag now " + dictSzValue('chkDebugFlag'), opmAll);
			break;

		case 'btnQuit':
			Go = false;
			break;
		default:
			break;
		}			  	
	}
}

function MyHandlers_OnTell(acoSender, acoReceiver, szMsg)
{
	if ( acoSender.szName != "Town Crier" ) {

            alertTellWav.Play();

        }
}

function MyHandlers_OnObjectCreatePlayer(aco)
{
	if (aco.szName == skapi.szName)
		return;

		alertPlayerWav.Play();
                SmincRed();
		skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - " + "Player Detected - " + aco.szName, opmChatWnd,22);
                skapi.WaitEvent(50,0);

}

function MyHandlers_OnAddToInventory(aco)
{
            if ( aco.szName == "Violet Ball" ) {

                    alertVioletWav.Play();

                    TotalViolet = skapi.CitemOfKindInInv("Violet Ball");
                    SmincGreen();
                    skapi.OutputLine("Collected  " + (TotalViolet - InitialViolet) + "  Violet Balls.  Carrying  " + TotalViolet + "  in total.", opmChatWnd,13);
                    if (DebugFlag) skapi.OutputLine("OnAddToInventory icon " + aco.icon, opmChatWnd,8);
                    skapi.WaitEvent(100,3);

                    if ( TotalViolet >= VioletMax ) {
                        Go = false;
                        SmincRed();
                        skapi.OutputLine("Maximum required has now been collected, exiting.", opmChatWnd,13);
                    }
            }
}

function myHandlers()
{
 	this.OnTell = MyHandlers_OnTell;
 	this.OnControlEvent = MyHandlers_OnControlEvent;
 	this.OnObjectCreatePlayer = MyHandlers_OnObjectCreatePlayer;
 	this.OnAddToInventory = MyHandlers_OnAddToInventory;
}
 
function fAddHandlers()
{
 	skapi.AddHandler(evidOnTell,h);
 	skapi.AddHandler(evidOnControlEvent,h);
 	skapi.AddHandler(evidOnObjectCreatePlayer,h);
 	skapi.AddHandler(evidOnAddToInventory,h);
} 
 
function fRemoveHandlers()
{
 	skapi.RemoveHandler(evidOnTell,h);
 	skapi.RemoveHandler(evidOnControlEvent,h);
 	skapi.RemoveHandler(evidOnObjectCreatePlayer,h);
 	skapi.RemoveHandler(evidOnAddToInventory,h);
}


function VioletBall()
{
                SmincAmber();
                Pyreal = skapi.CitemOfKindInInv("Pyreal");
                skapi.OutputLine("Pyreal :  " + Pyreal, opmChatWnd);

                BurdenCurrent = skapi.burdenCur;
                BurdenFull = skapi.burdenFull;  // this is 100%

                if (DebugFlag) {

                        SmincAmber();
                        skapi.OutputLine("Burden :  " + BurdenCurrent, opmChatWnd);
                        SmincAmber();
                        skapi.OutputLine("Burden Full :  " + BurdenFull, opmChatWnd);
                        SmincAmber();
                        skapi.OutputLine("Burden Ratio :  " + (BurdenCurrent/BurdenFull), opmChatWnd);

                }

                if ( (Pyreal > 0) && ( (BurdenCurrent/BurdenFull) < 3 ) ) {

                    if ( CrierAco == null ) {
                        CrierAco = FindCrier();
                        skapi.OutputLine("CrierLoc " + CrierAco.maploc, opmChatWnd);
                    }

                    var myloc= skapi.maplocCur; // My current location

                    if (myloc.Dist3DToMaploc(CrierAco.maploc) > 0.02 ) {
                        skapi.GoToMaploc(CrierAco.maploc, 0.01, false, true, 5000);
                        skapi.WaitEvent(5000,3);
                    }

                    skapi.SelectAco(CrierAco);

                    Pyreal1 = skapi.AcoFindInInv("Pyreal");
                    skapi.SelectAco(Pyreal1);

                    skapi.SetStackCount(1);

                    Pyreal1.MoveToStack(CrierAco);

                    skapi.WaitEvent(BallDelay*1000,3);

                } else {

                    if ( Pyreal = 0) {

                            SmincRed();
                            skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - Out of Pyreal, Quitting.", opmAll);

                    }

                    if ( (BurdenCurrent/BurdenFull) >= 3 ) {

                            SmincRed();
                            skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - Burden is at 300%, Quitting.", opmAll);

                    }

                    Go = false;                

                }
}

function FindCrier()
{
                var Criers = skapi.CoacoNew();             // Empty  collection
                var FilterCriers = skapi.AcfNew();         // Init  filter

                FilterCriers.ocm = ocmNPC;                 // Only check for NPC's
                FilterCriers.szName = "Town Crier";
                FilterCriers.distMax = 0.1;		   // Max distance to check
                Criers = FilterCriers.CoacoGet();
                Criers.Sort(skapi.sortbyDist);

                skapi.OutputLine("Found "+Criers.Count+" Crier(s).",opmChatWnd,5);

        	var CurrentCrier = Criers.Item(0);
                return CurrentCrier;
}

function PackCount()
{
            var NewPackCount = skapi.acoChar.cItemContents;

            if ( NewPackCount == 102 )
                Go = false;

//          Trap giving items away so that the max items before salvage is always honoured

            if ( NewPackCount < StartPackCount) {
                var Msg = " mins - Started with " + StartPackCount + " items in Main Pack,  you now have " + NewPackCount + " items.  Free Pack space for " + (FullPackCount-NewPackCount) + " items.";
                StartPackCount = NewPackCount;
            }

            if (( NewPackCount > StartPackCount ) && ( NewPackCount != OldPackCount ) ) {
                var Msg = " mins - Started with " + StartPackCount + " items in Main Pack,  you now have " + NewPackCount + " items.  Free Pack space for " + (FullPackCount-NewPackCount) + " items.";
                SmincAmber();
                skapi.OutputLine(Math.round(Start.cmsec/60000) + Msg, opmChatWnd,13);
                OldPackCount = NewPackCount;
            }

}

function Logout()
{
        MoveState = false;
        skapi.CancelNav();
	skapi.WaitEvent(100,3);
        SmincRed();
	skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - Logging Out...", opmAll);
	if (skapi.fInChatBuffer)
		skapi.Keys("{Tab}", kmoClick);
	skapi.Keys("~{ESC}", kmoClick);
	//skapi.Logout();
	while(skapi.plig != pligAtLogin && skapi.plig != pligNotRunning)
	{
		skapi.WaitEvent(250,3);
		if (skapi.fInChatBuffer)
			skapi.Keys("{Tab}", kmoClick);
		skapi.WaitEvent(250,3);
		skapi.Keys("~{ESC}", kmoClick);
		
		//skapi.Logout();
	}
	Go = false;
	skapi.WaitEvent(10000,3);
	skapi.Keys("n", kmoClick);
}

function SmincGreen()
{
//      yellow - green - yellow
 	skapi.OutputSz("<", opmChatWnd,4);
 	skapi.OutputSz("Violet", opmChatWnd,0);
 	skapi.OutputSz("> ", opmChatWnd,4);
}

function SmincAmber()
{
//      orange - yellow - orange
 	skapi.OutputSz("<", opmChatWnd,22);
 	skapi.OutputSz("Violet", opmChatWnd,4);
 	skapi.OutputSz("> ", opmChatWnd,22);
}

function SmincRed()
{
//      yellow - red - yellow
 	skapi.OutputSz("<", opmChatWnd,4);
 	skapi.OutputSz("Violet", opmChatWnd,6);
 	skapi.OutputSz("> ", opmChatWnd,4);
}


function Initialise()
{
 	skapi.OutputLine(PalVersion + " - Begin Macro" , opmAll,13);
 	skapi.OutputLine("Welcome " + skapi.szName , opmAll,13);

	pdwDxp3D = skapi.PdwMemlocFromSz("3DAreaWidth");
	pdwDyp3D = skapi.PdwMemlocFromSz("3DAreaHeight");
	pxtIsOpen = skapi.PxtNew(0, 0, 0x00000810, 0x0073869C);
 	SetupSchema();
 	skapi.ShowControls(szSchema, First);
 	Go = true;

        StartPackCount = skapi.acoChar.cItemContents;

        InitialViolet = skapi.CitemOfKindInInv("Violet Ball");
        TotalViolet = InitialViolet;

        StartHealth = skapi.SkinfoFromVital(vitalHealthMax).lvlCur;
        RunningClock = Start.cmsec;
        LastActionComplete = Start.cmsec/1000;

        CrierCheck = skapi.AcfNew();
        CrierCheck.ocm = ocmNPC;
        CrierCheck.distMax = 0.1;

 	skapi.OutputLine("Date : " + Date(), opmAll,14);
 	skapi.OutputLine("Current Location : " + skapi.maplocCur.sz + "      Heading : " + Math.round(skapi.maplocCur.head) + " degrees", opmAll,14);
 	skapi.OutputLine("Starting with " + StartPackCount + " items in Main Pack. Current Max Health " + StartHealth, opmAll, 13);

}
 

function main() 
{ 	
	var KeepRunning = true;
	var LoggedTime = skapi.TimerNew();
	var LogTime = 0;
 	var XPBegin = skapi.expTotal;
        Start = skapi.TimerNew();

	fAddHandlers();
	while (KeepRunning)
	{
		Initialise();
		while (Go)
		{
		var e;
		try {
                        if (DebugFlag) {
                            skapi.OutputLine("Cycle " + Math.round((Start.cmsec - RunningClock)/10)/100 + " seconds" , opmChatWnd,5);
                            skapi.OutputLine("LastActionComplete : " + Math.round(Start.cmsec/1000 - LastActionComplete) + " seconds.", opmChatWnd,9);
                            RunningClock = Start.cmsec;
                        }

			if ( Go && (CrierCheck.AcoGet() == null) ) {
                            SmincRed();
                            skapi.OutputLine("No Town Criers in Range, exiting script." , opmAll,5);
                            Go = false;
                            skapi.WaitEvent(2000,3);
                        }    

			if ( Go ) {
                            if (DebugFlag) skapi.OutputLine("1 - VioletBall ", opmChatWnd,11);
                            VioletBall();
			}
                        skapi.WaitEvent(100,0);

			if ( Go ) {
                            if (DebugFlag) skapi.OutputLine("2 - Packcount ", opmChatWnd,11);
                            PackCount();
			}
                        skapi.WaitEvent(100,0);

                    }
		catch (e)
                    {
			if (skapi.plig == pligNotRunning) {
                            Go = false;
			}
                    }
		}
		First = false;
 		skapi.RemoveControls("SMIncViolet");
		KeepRunning = false;
 	}
 	fRemoveHandlers();
        SmincRed();
 	skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - " + PalVersion + " - End Macro" , opmAll);
 	skapi.OutputLine("Collected  " + (TotalViolet - InitialViolet) + "  Violet Ball(s).", opmAll);
}
 
  function SetupSchema()
  {
  szSchema =
  	"<view icon='5432' title='SMIncViolet' \n" + 
  	"  width='180' height='160'>\n" + 
  	"  <control progid='DecalControls.FixedLayout'>\n" + 

  	"        <control name='chkMax' progid='DecalControls.CheckBox' text='Stop after' left='10' top='10' width='150' height='20' checked='" + DoMax + "'/>\n" +
  	"        <control name='edtMax' progid='DecalControls.Edit' text='" + VioletMax + "' left='80' top='10' width='20' height='20' />\n" +
  	"        <control name='txtMax2' progid='DecalControls.StaticText' text='Balls' left='95' top='10' width='50' height='20' />\n" +

  	"        <control name='chkFPL' progid='DecalControls.CheckBox' text='Logoff on Full Pack' left='10' top='35' width='150' height='20' checked='" + FullPackLog + "'/>\n" +
        "        <control name='txtFPC1' progid='DecalControls.StaticText' text='Pack Full at ' left='30' top='55' width='70' height='20' />\n" +
  	"        <control name='edtFPC' progid='DecalControls.Edit' text='" + FullPackCount + "' left='85' top='55' width='25' height='20' />\n" +
  	"        <control name='txtFPC2' progid='DecalControls.StaticText' text='items' left='110' top='55' width='50' height='20' />\n" +

  	"        <control name='chkDebugFlag' progid='DecalControls.CheckBox' text='Debug' left='10' top='80' width='70' height='20' checked='" + DebugFlag + "' />\n" +

  	"        <control name='txtVer' progid='DecalControls.StaticText' text='" + PalVersion.slice(13,30) + "' left='10' top='105' width='110' height='20' />\n" +

  	"      <control name='btnQuit'  progid='DecalControls.PushButton' text='Quit' left='120' top='100' width='50' height='20' />\n" + 
  	"  </control>\n" + 
 	"</view>";
}